lens-4.15.3: Lenses, Folds and Traversals

Copyright | (C) 2012-16 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | MTPCs
Safe Haskell | Safe
Language | Haskell98

Data.Tree.Lens

Description

Synopsis

- root :: Lens' (Tree a) a
- branches :: Lens' (Tree a) [Tree a]

# Documentation

root :: Lens' (Tree a) a #

A `Lens` that focuses on the root of a `Tree`.

    >>> view root $ Node 42 []
    42

branches :: Lens' (Tree a) [Tree a] #

A `Lens` returning the direct descendants of the root of a `Tree`

    view branches ≡ subForest